;------------------
;nocash nokey95 (c) 1/2019 martin korth
;------------------
.386
.model flat,STDCALL
.code
locals
;------------------
WM_DESTROY                  equ 2h
WM_CLOSE                    equ 10h
WM_KEYDOWN                  equ 100h
WM_KEYUP                    equ 101h
WM_SYSKEYDOWN               equ 104h
WM_SYSKEYUP                 equ 105h
MB_OK                       equ 0h
MB_YESNO                    equ 4h
IDYES                       equ 6
FALSE                       equ 0
TRUE                        equ 1
KEYEVENTF_EXTENDEDKEY       equ 1h
KEYEVENTF_KEYUP             equ 2h
VK_LWIN                     equ 5Bh
VK_RWIN                     equ 5Ch
VK_APPS                     equ 5Dh
WH_KEYBOARD                 equ 2   ;<-- this isn't low-level enough for VK_LWIN/VK_RWIN
WH_KEYBOARD_LL              equ 13  ;<-- this NEWER windows only?!?!
HC_ACTION                   equ 0
HC_GETNEXT                  equ 1
HC_SKIP                     equ 2
HC_NOREMOVE                 equ 3
HC_NOREM                    equ HC_NOREMOVE
HC_SYSMODALON               equ 4
HC_SYSMODALOFF              equ 5
SPI_SETSCREENSAVERRUNNING   equ 97
;---
includelib \talky\tasm32\import32.lib
extrn MessageBoxA           :proc
extrn ExitProcess           :proc
extrn GetModuleHandleA      :proc
extrn GetMessageA           :proc
extrn SetWindowsHookExA     :proc
extrn CallNextHookEx        :proc
extrn UnhookWindowsHookEx   :proc
extrn keybd_event           :proc
extrn SystemParametersInfoA :proc
extrn CreateWindowExA       :proc
;------------------
.data
 align 4
 hKeyboardHook  dd 0
 hInstance      dd 0
.code
;------------------
unhook_silly_keys:
 xor  eax,eax                           ;\
 xchg dword ptr [hKeyboardHook],eax     ;
 cmp  eax,0                             ;
 jz   short @@none                      ; unhook (if any)
 push eax                           ;\  ;
 call UnhookWindowsHookEx           ;/  ;
@@none:                                 ;/
;push 0                                 ;\
;push offset @@old                      ;
;push FALSE                             ; re-enable LWIN and RWIN under win9x
;push SPI_SETSCREENSAVERRUNNING         ;
;call SystemParametersInfoA             ;/
 ret
;------------------
hook_silly_keys:
 push 0                                 ;\
 push dword ptr [hInstance]  ;module    ;
 push offset @@key_hook_proc            ; hook
 push WH_KEYBOARD                       ;
 call SetWindowsHookExA                 ;
 mov  dword ptr [hKeyboardHook],eax     ;/
;push 0                                 ;\disable LWIN and RWIN under win9x
;push offset @@old                      ; however, this does also disable
;push TRUE                              ; CTRL+ALT+DEL, as well as other hotkeys
;push SPI_SETSCREENSAVERRUNNING         ; like ALT+TAB and CTRL+ESC
;call SystemParametersInfoA             ;/
 ret
;--- --- ---
@@key_hook_proc:   ;"KeyboardProc"
 push ebp                               ;\
 mov  ebp,esp                           ;
 @@nCode   equ dword ptr ss:[ebp+8]     ;
 @@wParam  equ dword ptr ss:[ebp+12]    ;
 @@lParam  equ dword ptr ss:[ebp+16]    ;/
;- - -
 cmp  @@nCode,0                         ;\
 js   short @@pass_on                   ;/
 cmp  @@nCode,HC_ACTION                 ;\
 jne  short @@pass_on                   ;/
 cmp  @@wParam,VK_LWIN                  ;\
 je   short @@reject                    ; check if it's one of the evil keys
 cmp  @@wParam,VK_RWIN                  ;
 je   short @@reject                    ;/
 jmp  short @@pass_on                   ;-
;---
@@reject:
 push 0               ;extra            ;\
 push KEYEVENTF_KEYUP ;flags            ; simulate a dummy key-release message
 push 0 ;or 01h       ;"BYTE" scan code ; (causes windows not to freak out with
 push 0 ;or VK_ESCAPE ;"BYTE" virt code ; start menu when releasing LWIN/RWIN)
 call keybd_event                       ;/
;mov  eax,1                             ;\optionally, don't forward message
;jmp  short @@done                      ;/
 mov eax,1
;---
@@pass_on:
 push @@lParam                          ;\
 push @@wParam                          ; forward message
 push @@nCode                           ; (this could be done before, or after
 push dword ptr [hKeyboardHook]         ; above keybd_event... but seems to make
 call CallNextHookEx                    ; no difference)
;cmp  eax,..   ;return value            ;/
;- - -
@@done:
 leave                                  ;\out: eax<>0 --> prevent Windows from passing the message to the rest of the hook chain or to the target window procedure (uh?)
 ret 12                                 ;/     eax=0 --> allow Windows to pass the message to the target window procedure, bypassing the remaining procedures in the chain (uh??)
;------------------
entrypoint:
 push 0                                 ;\
 call GetModuleHandleA                  ; get instance handle
 mov  dword ptr [hInstance],eax         ;/
 call hook_silly_keys                   ;-install hook
 push 0   ;param                        ;\
 push dword ptr [hInstance]             ;
 push 0   ;menu                         ;
 push 0   ;parent                       ; create an invisible dummy window
 push 100 ;height                       ; (required, else GetMesssage won't
 push 100 ;width                        ; work)
 push 0   ;yloc                         ;
 push 0   ;xloc                         ;
 push 0   ;style (namely not WS_VISIBLE);
 push offset @@name     ;name           ;
 push offset @@static   ;class          ;
 push 0   ;ext.style                    ;
 call CreateWindowExA                   ;
;mov  dword ptr [hWnd],eax              ;/
@@mainloop:                             ;\
 push 0                                 ;
 push 0                                 ; process/ignore all messages until
 push 0                                 ; receiving WM_CLOSE (eg. Ctrl+Alt+Del)
 push offset @@msg                      ;
 call GetMessageA ;get (or wait if none);
 or   eax,eax           ;\aka msg is    ;
 jz   short @@break     ;/WM_QUIT       ;
 cmp  dword ptr [@@msg_message],WM_CLOSE;
 jne  short @@mainloop                  ;/
@@break:
 call unhook_silly_keys                 ;-remove hook
 push 0   ;return value                 ;\quit
 call ExitProcess                       ;/
;---
@@static   db 'STATIC',0
@@name     db 'BLAH',0
;---
.data
align 4
@@msg:
 @@msg_hWnd      dd 0
 @@msg_message   dd 0
 @@msg_wParam    dd 0
 @@msg_lParam    dd 0
 @@msg_time      dd 0
 @@msg_pt_x      dd 0
 @@msg_pt_y      dd 0
.code
;------------------
end entrypoint

;---
;WM_KEYDOWN for LWIN/RWIN can be received and hooked without trickery.
;WM_KEYUP for LWIN/RWIN normally isn't received (even with SCREENSAVER trick).
;WM_KEYUP for LWIN/RWIN is received if ANOTHER key was pressed-or-released,
;while LWIN/RWIN were held down, and LWIN/RWIN then got released after that
;OTHER keystroke/keyrelease)


